import { __assign, __awaiter, __generator } from "tslib";
import { resolveDataBinds } from '../common';
import { set as lodashSet } from 'lodash-es';
import { app } from '../../app/global-api';
import { runtime } from '../adapter';
var DEFAULT_MAX_TIMEOUT = 10 * 1000;
export function emitEvent(trigger, listeners, args, scopeContext, dataContext) {
    if (listeners === void 0) { listeners = []; }
    if (scopeContext === void 0) { scopeContext = {}; }
    var targetListeners = listeners.filter(function (l) { return l.trigger === trigger; });
    function processListener(listener) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        return __awaiter(this, void 0, void 0, function () {
            var res, eventName, event_1, e_1, eventName, event_2;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        // 当前非捕获Event，再判断冒泡行为
                        if (!((_a = args === null || args === void 0 ? void 0 : args.event) === null || _a === void 0 ? void 0 : _a.isCapturePhase) && listener.noPropagation) {
                            ((_b = args === null || args === void 0 ? void 0 : args.domEvent) === null || _b === void 0 ? void 0 : _b.stopPropagation) && ((_c = args === null || args === void 0 ? void 0 : args.domEvent) === null || _c === void 0 ? void 0 : _c.stopPropagation());
                        }
                        if (!(((listener === null || listener === void 0 ? void 0 : listener.isCapturePhase) || false) === (((_d = args === null || args === void 0 ? void 0 : args.customEventData) === null || _d === void 0 ? void 0 : _d.isCapturePhase) || false))) return [3 /*break*/, 4];
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, invokeListener(listener, args, scopeContext, dataContext)];
                    case 2:
                        res = _j.sent();
                        eventName = "".concat(listener.key, ".success");
                        event_1 = {
                            detail: res,
                            isCapturePhase: !!((_e = args.event) === null || _e === void 0 ? void 0 : _e.isCapturePhase),
                            origin: args.event,
                            name: eventName,
                        };
                        emitEvent(eventName, listeners, __assign(__assign({}, args), { event: event_1, customEventData: event_1 }), scopeContext, dataContext);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _j.sent();
                        eventName = "".concat(listener.key, ".fail");
                        if (e_1.message) {
                            e_1.message = "".concat(((_g = (_f = args === null || args === void 0 ? void 0 : args.event) === null || _f === void 0 ? void 0 : _f.currentTarget) === null || _g === void 0 ? void 0 : _g.id) || '', "[").concat(listener.trigger, "] ").concat(e_1.message);
                        }
                        event_2 = {
                            detail: e_1,
                            origin: args.event,
                            isCapturePhase: !!((_h = args.event) === null || _h === void 0 ? void 0 : _h.isCapturePhase),
                            name: eventName,
                        };
                        emitEvent(eventName, listeners, __assign(__assign({}, args), { event: event_2, customEventData: event_2 }), scopeContext, dataContext);
                        // 之前 invoke 内部catch 了错误，不会抛错
                        // throw e
                        console.error("Action error: [".concat(listener.trigger, "]"), e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    if (!targetListeners.length && typeof trigger === 'string' && /\.fail$/.test(trigger)) {
        app.showToast({
            title: "\u4E8B\u4EF6\u54CD\u5E94\u5931\u8D25\uFF1A".concat(args.event.detail),
            icon: 'error',
        });
    }
    else {
        targetListeners.forEach(function (listener) {
            processListener(listener);
        });
    }
}
export function generateEmit(currentWidget, // page 节点暂未生成
injectContext, extraListeners, extraForContext) {
    if (currentWidget === void 0) { currentWidget = undefined; }
    if (injectContext === void 0) { injectContext = undefined; }
    if (extraListeners === void 0) { extraListeners = []; }
    if (extraForContext === void 0) { extraForContext = {}; }
    return function (trigger, listeners, eventData, forItems, domEvent, scopeContext, dataContext) {
        if (listeners === void 0) { listeners = []; }
        listeners = listeners.concat(extraListeners);
        if (injectContext === null || injectContext === void 0 ? void 0 : injectContext.emit) {
            return injectContext === null || injectContext === void 0 ? void 0 : injectContext.emit(trigger, listeners, eventData, forItems, domEvent, scopeContext, dataContext);
        }
        else {
            var event_3 = {
                detail: eventData,
                name: trigger,
                target: currentWidget,
                currentTarget: currentWidget,
                domEvent: domEvent,
            };
            emitEvent(trigger, listeners, {
                event: event_3,
                customEventData: event_3,
                forItems: __assign(__assign({}, forItems), extraForContext),
                domEvent: domEvent,
            }, scopeContext, dataContext);
        }
    };
}
function invokeListener(listener, args, scopeContext, dataContext) {
    var _a, _b, _c;
    var key = listener.key, instanceFunction = listener.instanceFunction, _d = listener.data, data = _d === void 0 ? {} : _d, _e = listener.dataBinds, dataBinds = _e === void 0 ? {} : _e;
    if (!instanceFunction) {
        try {
            // @ts-ignore
            (_b = (_a = window._aegis) === null || _a === void 0 ? void 0 : _a.error) === null || _b === void 0 ? void 0 : _b.call(_a, 'SYSTEM_ERROR: listener not found', listener);
            console.error('$page current hander', (_c = runtime === null || runtime === void 0 ? void 0 : runtime['$page']) === null || _c === void 0 ? void 0 : _c.handler);
        }
        catch (e) {
            debugger;
        }
        throw new Error("".concat(key, " handler \u672A\u627E\u5230'"));
    }
    // ToDo resolve databinds
    var action = instanceFunction;
    var resolvedData = __assign({}, data);
    var resolvedDataBinds = resolveDataBinds(dataBinds, args.forItems, { event: args.event }, scopeContext, true, dataContext);
    // eslint-disable-next-line no-restricted-syntax
    for (var key_1 in resolvedDataBinds) {
        if (resolvedDataBinds[key_1] && resolvedDataBinds[key_1].__type === 'scopedValue') {
            try {
                lodashSet(resolvedData, key_1, resolvedDataBinds[key_1].getValue(scopeContext));
            }
            catch (e) {
                lodashSet(resolvedData, key_1, '');
            }
        }
        else {
            lodashSet(resolvedData, key_1, resolvedDataBinds[key_1]);
        }
    }
    var params = __assign({ data: resolvedData }, args);
    return action(params);
}
